/*=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
=-=  L3g0.inc
=-=     A library of L3G0 blocks for the POV-ray
=-=     ray tracing program.
=-=
=-= DISCLAIMER:
=-=  L3G0 is a set of objects which look similar to
=-=  LEGO(R) brand building bricks.  This library used to be
=-=  ditributed under the name "legolib.ray", but the name
=-=  has been changed to make clear that this is not a product
=-=  of INTERLEGO AG.  Care has been taken to ensure that (hopefully)
=-=  there are no violations of copyrights.
=-=
=-=  LEGO(R) is a trademark of INTERLEGO AG.
=-=
=-=
=-= NAMING CONVENTION:
=-=  All parts and macros defined in these files begin either with
=-=  "l3g0_", "ll_", or "LL_".  Hopefully this will avoid any naming
=-=  conflicts with other libraries.
=-=
=-= ORIGINAL (Rayshade) VERSION:
=-=     Version 7.0, April 1996.
=-=     originally written by:
=-=             Paul Gyugyi <paul@gyugyi.com>
=-=     with enhancements from:
=-=             Edward van der Jagt <bivdjagt@cs.few.eur.nl>
=-=             Jason Eddy <jeddy@pcsedu.com>
=-=             Stefan Gustavson <stefang@isy.liu.se>
=-=             Bertrand Petit <elrond@imladris.frmug.fr.net>
=-=             Craig Kolb <cek@Princeton.EDU>
=-=             Ken Koleda <Kenkoleda@aol.com>
=-=
=-= POV-ray VERSION:
=-=     Version 1.0, September 1996.
=-=     converted by :
=-=             Filip Spacek <spacek@geocities.com>
=-=
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=*/

/* This is to prevent re-inclusion of the same header. */

/* include the full library */
#include "ll_sizes.inc"
#include "ll_commn.inc"
#include "ll_color.inc"
#include "ll_brick.inc"
#include "ll_flats.inc"
#include "ll_bases.inc"
#include "ll_ramps.inc"
#include "ll_tiles.inc"
#include "ll_axle.inc"
#include "ll_cylnd.inc"
#include "ll_techg.inc"
#include "ll_techn.inc"
#include "ll_wheel.inc"
#include "ll_wings.inc"
#include "ll_gizmo.inc"
#include "ll_mnfig.inc"
#include "ll_wshld.inc"
#include "ll_trees.inc"
#include "ll_burps.inc"
#include "ll_misc.inc"
#include "ll_rollb.inc"
#include "ll_arch.inc"
#include "ll_road.inc"

